// coverage:ignore-file
// GENERATED CODE - DO NOT MODIFY BY HAND
// ignore_for_file: type=lint
// ignore_for_file:

part of 'forms.dart';

// **************************************************************************
// ReactiveFormsGenerator
// **************************************************************************

class ReactiveCreateProjectFormConsumer extends StatelessWidget {
  const ReactiveCreateProjectFormConsumer({
    Key? key,
    required this.builder,
    this.child,
  }) : super(key: key);

  final Widget? child;

  final Widget Function(
      BuildContext context, CreateProjectForm formModel, Widget? child) builder;

  @override
  Widget build(BuildContext context) {
    final formModel = ReactiveCreateProjectForm.of(context);

    if (formModel is! CreateProjectForm) {
      throw FormControlParentNotFoundException(this);
    }
    return builder(context, formModel, child);
  }
}

class CreateProjectFormInheritedStreamer extends InheritedStreamer<dynamic> {
  const CreateProjectFormInheritedStreamer({
    Key? key,
    required this.form,
    required Stream<dynamic> stream,
    required Widget child,
  }) : super(
          stream,
          child,
          key: key,
        );

  final CreateProjectForm form;
}

class ReactiveCreateProjectForm extends StatelessWidget {
  const ReactiveCreateProjectForm({
    Key? key,
    required this.form,
    required this.child,
    this.onWillPop,
  }) : super(key: key);

  final Widget child;

  final CreateProjectForm form;

  final WillPopCallback? onWillPop;

  static CreateProjectForm? of(
    BuildContext context, {
    bool listen = true,
  }) {
    if (listen) {
      return context
          .dependOnInheritedWidgetOfExactType<
              CreateProjectFormInheritedStreamer>()
          ?.form;
    }

    final element = context.getElementForInheritedWidgetOfExactType<
        CreateProjectFormInheritedStreamer>();
    return element == null
        ? null
        : (element.widget as CreateProjectFormInheritedStreamer).form;
  }

  @override
  Widget build(BuildContext context) {
    return CreateProjectFormInheritedStreamer(
      form: form,
      stream: form.form.statusChanged,
      child: WillPopScope(
        onWillPop: onWillPop,
        child: child,
      ),
    );
  }
}

class CreateProjectFormBuilder extends StatefulWidget {
  const CreateProjectFormBuilder({
    Key? key,
    this.model,
    this.child,
    this.onWillPop,
    required this.builder,
    this.initState,
  }) : super(key: key);

  final CreateProject? model;

  final Widget? child;

  final WillPopCallback? onWillPop;

  final Widget Function(
      BuildContext context, CreateProjectForm formModel, Widget? child) builder;

  final void Function(BuildContext context, CreateProjectForm formModel)?
      initState;

  @override
  _CreateProjectFormBuilderState createState() =>
      _CreateProjectFormBuilderState();
}

class _CreateProjectFormBuilderState extends State<CreateProjectFormBuilder> {
  late FormGroup _form;

  late CreateProjectForm _formModel;

  @override
  void initState() {
    _form = FormGroup({});
    _formModel = CreateProjectForm(widget.model, _form, null);

    final elements = _formModel.formElements();
    _form.setValidators(elements.validators);
    _form.setAsyncValidators(elements.asyncValidators);

    if (elements.disabled) {
      _form.markAsDisabled();
    }

    _form.addAll(elements.controls);

    widget.initState?.call(context, _formModel);

    super.initState();
  }

  @override
  void dispose() {
    _form.dispose();
    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    return ReactiveCreateProjectForm(
      form: _formModel,
      onWillPop: widget.onWillPop,
      child: ReactiveFormBuilder(
        form: () => _form,
        onWillPop: widget.onWillPop,
        builder: (BuildContext context, FormGroup formGroup, Widget? child) =>
            widget.builder(context, _formModel, widget.child),
        child: widget.child,
      ),
    );
  }
}

class CreateProjectForm implements FormModel<CreateProject> {
  CreateProjectForm(
    this.createProject,
    this.form,
    this.path,
  ) {}

  static String doiControlName = "doi";

  static String labelControlName = "label";

  static String notesControlName = "notes";

  static String datasetIdsControlName = "datasetIds";

  final CreateProject? createProject;

  final FormGroup form;

  final String? path;

  String doiControlPath() => pathBuilder(doiControlName);
  String labelControlPath() => pathBuilder(labelControlName);
  String notesControlPath() => pathBuilder(notesControlName);
  String datasetIdsControlPath() => pathBuilder(datasetIdsControlName);
  String get _doiValue => doiControl.value ?? "";
  String? get _labelValue => labelControl?.value;
  String? get _notesValue => notesControl?.value;
  List<String>? get _datasetIdsValue => datasetIdsControl?.value;
  bool get containsDoi {
    try {
      form.control(doiControlPath());
      return true;
    } catch (e) {
      return false;
    }
  }

  bool get containsLabel {
    try {
      form.control(labelControlPath());
      return true;
    } catch (e) {
      return false;
    }
  }

  bool get containsNotes {
    try {
      form.control(notesControlPath());
      return true;
    } catch (e) {
      return false;
    }
  }

  bool get containsDatasetIds {
    try {
      form.control(datasetIdsControlPath());
      return true;
    } catch (e) {
      return false;
    }
  }

  Object? get doiErrors => doiControl.errors;
  Object? get labelErrors => labelControl?.errors;
  Object? get notesErrors => notesControl?.errors;
  Object? get datasetIdsErrors => datasetIdsControl?.errors;
  void get doiFocus => form.focus(doiControlPath());
  void get labelFocus => form.focus(labelControlPath());
  void get notesFocus => form.focus(notesControlPath());
  void get datasetIdsFocus => form.focus(datasetIdsControlPath());
  void labelRemove({
    bool updateParent = true,
    bool emitEvent = true,
  }) {
    if (containsLabel) {
      final controlPath = path;
      if (controlPath == null) {
        form.removeControl(
          labelControlName,
          updateParent: updateParent,
          emitEvent: emitEvent,
        );
      } else {
        final formGroup = form.control(controlPath);

        if (formGroup is FormGroup) {
          formGroup.removeControl(
            labelControlName,
            updateParent: updateParent,
            emitEvent: emitEvent,
          );
        }
      }
    }
  }

  void notesRemove({
    bool updateParent = true,
    bool emitEvent = true,
  }) {
    if (containsNotes) {
      final controlPath = path;
      if (controlPath == null) {
        form.removeControl(
          notesControlName,
          updateParent: updateParent,
          emitEvent: emitEvent,
        );
      } else {
        final formGroup = form.control(controlPath);

        if (formGroup is FormGroup) {
          formGroup.removeControl(
            notesControlName,
            updateParent: updateParent,
            emitEvent: emitEvent,
          );
        }
      }
    }
  }

  void datasetIdsRemove({
    bool updateParent = true,
    bool emitEvent = true,
  }) {
    if (containsDatasetIds) {
      final controlPath = path;
      if (controlPath == null) {
        form.removeControl(
          datasetIdsControlName,
          updateParent: updateParent,
          emitEvent: emitEvent,
        );
      } else {
        final formGroup = form.control(controlPath);

        if (formGroup is FormGroup) {
          formGroup.removeControl(
            datasetIdsControlName,
            updateParent: updateParent,
            emitEvent: emitEvent,
          );
        }
      }
    }
  }

  void doiValueUpdate(
    String value, {
    bool updateParent = true,
    bool emitEvent = true,
  }) {
    doiControl.updateValue(value,
        updateParent: updateParent, emitEvent: emitEvent);
  }

  void labelValueUpdate(
    String? value, {
    bool updateParent = true,
    bool emitEvent = true,
  }) {
    labelControl?.updateValue(value,
        updateParent: updateParent, emitEvent: emitEvent);
  }

  void notesValueUpdate(
    String? value, {
    bool updateParent = true,
    bool emitEvent = true,
  }) {
    notesControl?.updateValue(value,
        updateParent: updateParent, emitEvent: emitEvent);
  }

  void datasetIdsValueUpdate(
    List<String>? value, {
    bool updateParent = true,
    bool emitEvent = true,
  }) {
    datasetIdsControl?.updateValue(value,
        updateParent: updateParent, emitEvent: emitEvent);
  }

  void doiValuePatch(
    String value, {
    bool updateParent = true,
    bool emitEvent = true,
  }) {
    doiControl.patchValue(value,
        updateParent: updateParent, emitEvent: emitEvent);
  }

  void labelValuePatch(
    String? value, {
    bool updateParent = true,
    bool emitEvent = true,
  }) {
    labelControl?.patchValue(value,
        updateParent: updateParent, emitEvent: emitEvent);
  }

  void notesValuePatch(
    String? value, {
    bool updateParent = true,
    bool emitEvent = true,
  }) {
    notesControl?.patchValue(value,
        updateParent: updateParent, emitEvent: emitEvent);
  }

  void datasetIdsValuePatch(
    List<String>? value, {
    bool updateParent = true,
    bool emitEvent = true,
  }) {
    datasetIdsControl?.patchValue(value,
        updateParent: updateParent, emitEvent: emitEvent);
  }

  void doiValueReset(
    String value, {
    bool updateParent = true,
    bool emitEvent = true,
    bool removeFocus = false,
    bool? disabled,
  }) =>
      doiControl.reset(
          value: value, updateParent: updateParent, emitEvent: emitEvent);
  void labelValueReset(
    String? value, {
    bool updateParent = true,
    bool emitEvent = true,
    bool removeFocus = false,
    bool? disabled,
  }) =>
      labelControl?.reset(
          value: value, updateParent: updateParent, emitEvent: emitEvent);
  void notesValueReset(
    String? value, {
    bool updateParent = true,
    bool emitEvent = true,
    bool removeFocus = false,
    bool? disabled,
  }) =>
      notesControl?.reset(
          value: value, updateParent: updateParent, emitEvent: emitEvent);
  void datasetIdsValueReset(
    List<String>? value, {
    bool updateParent = true,
    bool emitEvent = true,
    bool removeFocus = false,
    bool? disabled,
  }) =>
      datasetIdsControl?.reset(
          value: value, updateParent: updateParent, emitEvent: emitEvent);
  FormControl<String> get doiControl =>
      form.control(doiControlPath()) as FormControl<String>;
  FormControl<String>? get labelControl => containsLabel
      ? form.control(labelControlPath()) as FormControl<String>?
      : null;
  FormControl<String>? get notesControl => containsNotes
      ? form.control(notesControlPath()) as FormControl<String>?
      : null;
  FormControl<List<String>>? get datasetIdsControl => containsDatasetIds
      ? form.control(datasetIdsControlPath()) as FormControl<List<String>>?
      : null;
  void doiSetDisabled(
    bool disabled, {
    bool updateParent = true,
    bool emitEvent = true,
  }) {
    if (disabled) {
      doiControl.markAsDisabled(
        updateParent: updateParent,
        emitEvent: emitEvent,
      );
    } else {
      doiControl.markAsEnabled(
        updateParent: updateParent,
        emitEvent: emitEvent,
      );
    }
  }

  void labelSetDisabled(
    bool disabled, {
    bool updateParent = true,
    bool emitEvent = true,
  }) {
    if (disabled) {
      labelControl?.markAsDisabled(
        updateParent: updateParent,
        emitEvent: emitEvent,
      );
    } else {
      labelControl?.markAsEnabled(
        updateParent: updateParent,
        emitEvent: emitEvent,
      );
    }
  }

  void notesSetDisabled(
    bool disabled, {
    bool updateParent = true,
    bool emitEvent = true,
  }) {
    if (disabled) {
      notesControl?.markAsDisabled(
        updateParent: updateParent,
        emitEvent: emitEvent,
      );
    } else {
      notesControl?.markAsEnabled(
        updateParent: updateParent,
        emitEvent: emitEvent,
      );
    }
  }

  void datasetIdsSetDisabled(
    bool disabled, {
    bool updateParent = true,
    bool emitEvent = true,
  }) {
    if (disabled) {
      datasetIdsControl?.markAsDisabled(
        updateParent: updateParent,
        emitEvent: emitEvent,
      );
    } else {
      datasetIdsControl?.markAsEnabled(
        updateParent: updateParent,
        emitEvent: emitEvent,
      );
    }
  }

  CreateProject get model {
    if (!form.valid) {
      debugPrint(
        'Prefer not to call `model` on non-valid form it could cause unexpected exceptions in case you created a non-nullable field in model and expect it to be guarded by some kind of `required` validator.',
      );
    }
    return CreateProject(
        doi: _doiValue,
        label: _labelValue,
        notes: _notesValue,
        datasetIds: _datasetIdsValue);
  }

  CreateProjectForm copyWithPath(String? path) {
    return CreateProjectForm(createProject, form, path);
  }

  void updateValue(
    CreateProject value, {
    bool updateParent = true,
    bool emitEvent = true,
  }) =>
      form.updateValue(
          CreateProjectForm(value, FormGroup({}), null).formElements().rawValue,
          updateParent: updateParent,
          emitEvent: emitEvent);
  void resetValue(
    CreateProject value, {
    bool updateParent = true,
    bool emitEvent = true,
  }) =>
      form.reset(
          value: CreateProjectForm(value, FormGroup({}), null)
              .formElements()
              .rawValue,
          updateParent: updateParent,
          emitEvent: emitEvent);
  void reset({
    bool updateParent = true,
    bool emitEvent = true,
  }) =>
      form.reset(
          value: formElements().rawValue,
          updateParent: updateParent,
          emitEvent: emitEvent);
  String pathBuilder(String? pathItem) =>
      [path, pathItem].whereType<String>().join(".");
  FormGroup formElements() => FormGroup({
        doiControlName: FormControl<String>(
            value: createProject?.doi,
            validators: [requiredValidator],
            asyncValidators: [],
            asyncValidatorsDebounceTime: 250,
            disabled: false,
            touched: false),
        labelControlName: FormControl<String>(
            value: createProject?.label,
            validators: [],
            asyncValidators: [],
            asyncValidatorsDebounceTime: 250,
            disabled: false,
            touched: false),
        notesControlName: FormControl<String>(
            value: createProject?.notes,
            validators: [],
            asyncValidators: [],
            asyncValidatorsDebounceTime: 250,
            disabled: false,
            touched: false),
        datasetIdsControlName: FormControl<List<String>>(
            value: createProject?.datasetIds,
            validators: [],
            asyncValidators: [],
            asyncValidatorsDebounceTime: 250,
            disabled: false,
            touched: false)
      },
          validators: [],
          asyncValidators: [],
          asyncValidatorsDebounceTime: 250,
          disabled: false);
}

class ReactiveCreateProjectFormArrayBuilder<T> extends StatelessWidget {
  const ReactiveCreateProjectFormArrayBuilder({
    Key? key,
    this.control,
    this.formControl,
    this.builder,
    required this.itemBuilder,
  })  : assert(control != null || formControl != null,
            "You have to specify `control` or `formControl`!"),
        super(key: key);

  final FormArray<T>? formControl;

  final FormArray<T>? Function(CreateProjectForm formModel)? control;

  final Widget Function(BuildContext context, List<Widget> itemList,
      CreateProjectForm formModel)? builder;

  final Widget Function(
          BuildContext context, int i, T? item, CreateProjectForm formModel)
      itemBuilder;

  @override
  Widget build(BuildContext context) {
    final formModel = ReactiveCreateProjectForm.of(context);

    if (formModel == null) {
      throw FormControlParentNotFoundException(this);
    }

    return ReactiveFormArray<T>(
      formArray: formControl ?? control?.call(formModel),
      builder: (context, formArray, child) {
        final itemList = (formArray.value ?? [])
            .asMap()
            .map((i, item) {
              return MapEntry(
                i,
                itemBuilder(
                  context,
                  i,
                  item,
                  formModel,
                ),
              );
            })
            .values
            .toList();

        return builder?.call(
              context,
              itemList,
              formModel,
            ) ??
            Column(children: itemList);
      },
    );
  }
}

class ReactiveCreateProjectFormFormGroupArrayBuilder<V>
    extends StatelessWidget {
  const ReactiveCreateProjectFormFormGroupArrayBuilder({
    Key? key,
    this.extended,
    this.getExtended,
    this.builder,
    required this.itemBuilder,
  })  : assert(extended != null || getExtended != null,
            "You have to specify `control` or `formControl`!"),
        super(key: key);

  final ExtendedControl<List<Map<String, Object?>?>, List<V>>? extended;

  final ExtendedControl<List<Map<String, Object?>?>, List<V>> Function(
      CreateProjectForm formModel)? getExtended;

  final Widget Function(BuildContext context, List<Widget> itemList,
      CreateProjectForm formModel)? builder;

  final Widget Function(
          BuildContext context, int i, V? item, CreateProjectForm formModel)
      itemBuilder;

  @override
  Widget build(BuildContext context) {
    final formModel = ReactiveCreateProjectForm.of(context);

    if (formModel == null) {
      throw FormControlParentNotFoundException(this);
    }

    final value = (extended ?? getExtended?.call(formModel))!;

    return StreamBuilder<List<Map<String, Object?>?>?>(
      stream: value.control.valueChanges,
      builder: (context, snapshot) {
        final itemList = (value.value() ?? <V>[])
            .asMap()
            .map((i, item) => MapEntry(
                  i,
                  itemBuilder(
                    context,
                    i,
                    item,
                    formModel,
                  ),
                ))
            .values
            .toList();

        return builder?.call(
              context,
              itemList,
              formModel,
            ) ??
            Column(children: itemList);
      },
    );
  }
}

class ReactiveCreateDatasetFormConsumer extends StatelessWidget {
  const ReactiveCreateDatasetFormConsumer({
    Key? key,
    required this.builder,
    this.child,
  }) : super(key: key);

  final Widget? child;

  final Widget Function(
      BuildContext context, CreateDatasetForm formModel, Widget? child) builder;

  @override
  Widget build(BuildContext context) {
    final formModel = ReactiveCreateDatasetForm.of(context);

    if (formModel is! CreateDatasetForm) {
      throw FormControlParentNotFoundException(this);
    }
    return builder(context, formModel, child);
  }
}

class CreateDatasetFormInheritedStreamer extends InheritedStreamer<dynamic> {
  const CreateDatasetFormInheritedStreamer({
    Key? key,
    required this.form,
    required Stream<dynamic> stream,
    required Widget child,
  }) : super(
          stream,
          child,
          key: key,
        );

  final CreateDatasetForm form;
}

class ReactiveCreateDatasetForm extends StatelessWidget {
  const ReactiveCreateDatasetForm({
    Key? key,
    required this.form,
    required this.child,
    this.onWillPop,
  }) : super(key: key);

  final Widget child;

  final CreateDatasetForm form;

  final WillPopCallback? onWillPop;

  static CreateDatasetForm? of(
    BuildContext context, {
    bool listen = true,
  }) {
    if (listen) {
      return context
          .dependOnInheritedWidgetOfExactType<
              CreateDatasetFormInheritedStreamer>()
          ?.form;
    }

    final element = context.getElementForInheritedWidgetOfExactType<
        CreateDatasetFormInheritedStreamer>();
    return element == null
        ? null
        : (element.widget as CreateDatasetFormInheritedStreamer).form;
  }

  @override
  Widget build(BuildContext context) {
    return CreateDatasetFormInheritedStreamer(
      form: form,
      stream: form.form.statusChanged,
      child: WillPopScope(
        onWillPop: onWillPop,
        child: child,
      ),
    );
  }
}

class CreateDatasetFormBuilder extends StatefulWidget {
  const CreateDatasetFormBuilder({
    Key? key,
    this.model,
    this.child,
    this.onWillPop,
    required this.builder,
    this.initState,
  }) : super(key: key);

  final CreateDataset? model;

  final Widget? child;

  final WillPopCallback? onWillPop;

  final Widget Function(
      BuildContext context, CreateDatasetForm formModel, Widget? child) builder;

  final void Function(BuildContext context, CreateDatasetForm formModel)?
      initState;

  @override
  _CreateDatasetFormBuilderState createState() =>
      _CreateDatasetFormBuilderState();
}

class _CreateDatasetFormBuilderState extends State<CreateDatasetFormBuilder> {
  late FormGroup _form;

  late CreateDatasetForm _formModel;

  @override
  void initState() {
    _form = FormGroup({});
    _formModel = CreateDatasetForm(widget.model, _form, null);

    final elements = _formModel.formElements();
    _form.setValidators(elements.validators);
    _form.setAsyncValidators(elements.asyncValidators);

    if (elements.disabled) {
      _form.markAsDisabled();
    }

    _form.addAll(elements.controls);

    widget.initState?.call(context, _formModel);

    super.initState();
  }

  @override
  void dispose() {
    _form.dispose();
    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    return ReactiveCreateDatasetForm(
      form: _formModel,
      onWillPop: widget.onWillPop,
      child: ReactiveFormBuilder(
        form: () => _form,
        onWillPop: widget.onWillPop,
        builder: (BuildContext context, FormGroup formGroup, Widget? child) =>
            widget.builder(context, _formModel, widget.child),
        child: widget.child,
      ),
    );
  }
}

class CreateDatasetForm implements FormModel<CreateDataset> {
  CreateDatasetForm(
    this.createDataset,
    this.form,
    this.path,
  ) {
    animalForm = AnimalForm(createDataset?.animal, form, pathBuilder('animal'));
    microscopyMethodForm = MicroscopyMethodForm(
        createDataset?.microscopyMethod, form, pathBuilder('microscopyMethod'));
    targetedMutationTargetedMutationForm = (createDataset?.targetedMutation ??
            [])
        .asMap()
        .map((k, v) => MapEntry(k,
            TargetedMutationForm(v, form, pathBuilder("targetedMutation.$k"))))
        .values
        .toList();
  }

  static String labelControlName = "label";

  static String notesControlName = "notes";

  static String animalControlName = "animal";

  static String targetedMutationControlName = "targetedMutation";

  static String microscopyMethodControlName = "microscopyMethod";

  static String brainStructureControlName = "brainStructure";

  late AnimalForm animalForm;

  late MicroscopyMethodForm microscopyMethodForm;

  final CreateDataset? createDataset;

  final FormGroup form;

  final String? path;

  late List<TargetedMutationForm> targetedMutationTargetedMutationForm;

  String labelControlPath() => pathBuilder(labelControlName);
  String notesControlPath() => pathBuilder(notesControlName);
  String brainStructureControlPath() => pathBuilder(brainStructureControlName);
  String animalControlPath() => pathBuilder(animalControlName);
  String microscopyMethodControlPath() =>
      pathBuilder(microscopyMethodControlName);
  String targetedMutationControlPath() =>
      pathBuilder(targetedMutationControlName);
  String? get _labelValue => labelControl?.value;
  String? get _notesValue => notesControl?.value;
  BrainStructure? get _brainStructureValue => brainStructureControl?.value;
  Animal? get _animalValue => animalForm.model;
  MicroscopyMethod? get _microscopyMethodValue => microscopyMethodForm.model;
  List<TargetedMutation> get _targetedMutationValue =>
      targetedMutationTargetedMutationForm
          .asMap()
          .map(
            (k, v) => MapEntry(
              k,
              v
                  .copyWithPath(
                    pathBuilder("targetedMutation.$k"),
                  )
                  .model,
            ),
          )
          .values
          .toList();
  bool get containsLabel {
    try {
      form.control(labelControlPath());
      return true;
    } catch (e) {
      return false;
    }
  }

  bool get containsNotes {
    try {
      form.control(notesControlPath());
      return true;
    } catch (e) {
      return false;
    }
  }

  bool get containsBrainStructure {
    try {
      form.control(brainStructureControlPath());
      return true;
    } catch (e) {
      return false;
    }
  }

  bool get containsAnimal {
    try {
      form.control(animalControlPath());
      return true;
    } catch (e) {
      return false;
    }
  }

  bool get containsMicroscopyMethod {
    try {
      form.control(microscopyMethodControlPath());
      return true;
    } catch (e) {
      return false;
    }
  }

  bool get containsTargetedMutation {
    try {
      form.control(targetedMutationControlPath());
      return true;
    } catch (e) {
      return false;
    }
  }

  Object? get labelErrors => labelControl?.errors;
  Object? get notesErrors => notesControl?.errors;
  Object? get brainStructureErrors => brainStructureControl?.errors;
  Object? get animalErrors => animalControl?.errors;
  Object? get microscopyMethodErrors => microscopyMethodControl?.errors;
  Object? get targetedMutationErrors => targetedMutationControl.errors;
  void get labelFocus => form.focus(labelControlPath());
  void get notesFocus => form.focus(notesControlPath());
  void get brainStructureFocus => form.focus(brainStructureControlPath());
  void get animalFocus => form.focus(animalControlPath());
  void get microscopyMethodFocus => form.focus(microscopyMethodControlPath());
  void get targetedMutationFocus => form.focus(targetedMutationControlPath());
  void labelRemove({
    bool updateParent = true,
    bool emitEvent = true,
  }) {
    if (containsLabel) {
      final controlPath = path;
      if (controlPath == null) {
        form.removeControl(
          labelControlName,
          updateParent: updateParent,
          emitEvent: emitEvent,
        );
      } else {
        final formGroup = form.control(controlPath);

        if (formGroup is FormGroup) {
          formGroup.removeControl(
            labelControlName,
            updateParent: updateParent,
            emitEvent: emitEvent,
          );
        }
      }
    }
  }

  void notesRemove({
    bool updateParent = true,
    bool emitEvent = true,
  }) {
    if (containsNotes) {
      final controlPath = path;
      if (controlPath == null) {
        form.removeControl(
          notesControlName,
          updateParent: updateParent,
          emitEvent: emitEvent,
        );
      } else {
        final formGroup = form.control(controlPath);

        if (formGroup is FormGroup) {
          formGroup.removeControl(
            notesControlName,
            updateParent: updateParent,
            emitEvent: emitEvent,
          );
        }
      }
    }
  }

  void brainStructureRemove({
    bool updateParent = true,
    bool emitEvent = true,
  }) {
    if (containsBrainStructure) {
      final controlPath = path;
      if (controlPath == null) {
        form.removeControl(
          brainStructureControlName,
          updateParent: updateParent,
          emitEvent: emitEvent,
        );
      } else {
        final formGroup = form.control(controlPath);

        if (formGroup is FormGroup) {
          formGroup.removeControl(
            brainStructureControlName,
            updateParent: updateParent,
            emitEvent: emitEvent,
          );
        }
      }
    }
  }

  void animalRemove({
    bool updateParent = true,
    bool emitEvent = true,
  }) {
    if (containsAnimal) {
      final controlPath = path;
      if (controlPath == null) {
        form.removeControl(
          animalControlName,
          updateParent: updateParent,
          emitEvent: emitEvent,
        );
      } else {
        final formGroup = form.control(controlPath);

        if (formGroup is FormGroup) {
          formGroup.removeControl(
            animalControlName,
            updateParent: updateParent,
            emitEvent: emitEvent,
          );
        }
      }
    }
  }

  void microscopyMethodRemove({
    bool updateParent = true,
    bool emitEvent = true,
  }) {
    if (containsMicroscopyMethod) {
      final controlPath = path;
      if (controlPath == null) {
        form.removeControl(
          microscopyMethodControlName,
          updateParent: updateParent,
          emitEvent: emitEvent,
        );
      } else {
        final formGroup = form.control(controlPath);

        if (formGroup is FormGroup) {
          formGroup.removeControl(
            microscopyMethodControlName,
            updateParent: updateParent,
            emitEvent: emitEvent,
          );
        }
      }
    }
  }

  void labelValueUpdate(
    String? value, {
    bool updateParent = true,
    bool emitEvent = true,
  }) {
    labelControl?.updateValue(value,
        updateParent: updateParent, emitEvent: emitEvent);
  }

  void notesValueUpdate(
    String? value, {
    bool updateParent = true,
    bool emitEvent = true,
  }) {
    notesControl?.updateValue(value,
        updateParent: updateParent, emitEvent: emitEvent);
  }

  void brainStructureValueUpdate(
    BrainStructure? value, {
    bool updateParent = true,
    bool emitEvent = true,
  }) {
    brainStructureControl?.updateValue(value,
        updateParent: updateParent, emitEvent: emitEvent);
  }

  void animalValueUpdate(
    Animal? value, {
    bool updateParent = true,
    bool emitEvent = true,
  }) {
    animalControl?.updateValue(
        AnimalForm(value, FormGroup({}), null).formElements().rawValue,
        updateParent: updateParent,
        emitEvent: emitEvent);
  }

  void microscopyMethodValueUpdate(
    MicroscopyMethod? value, {
    bool updateParent = true,
    bool emitEvent = true,
  }) {
    microscopyMethodControl?.updateValue(
        MicroscopyMethodForm(value, FormGroup({}), null)
            .formElements()
            .rawValue,
        updateParent: updateParent,
        emitEvent: emitEvent);
  }

  void targetedMutationValueUpdate(
    List<TargetedMutation> value, {
    bool updateParent = true,
    bool emitEvent = true,
  }) {
    if ((value).isEmpty) {
      targetedMutationClear(updateParent: updateParent, emitEvent: emitEvent);

      return;
    }

    final updateList = (value)
        .asMap()
        .map(
          (k, v) => MapEntry(
            k,
            TargetedMutationForm(v, form, pathBuilder("targetedMutation.$k")),
          ),
        )
        .values
        .toList();

    targetedMutationTargetedMutationForm.clear();
    targetedMutationTargetedMutationForm.addAll(updateList);

    final toUpdate = <TargetedMutationForm>[];
    final toAdd = <TargetedMutationForm>[];

    updateList.asMap().forEach((k, v) {
      if (targetedMutationTargetedMutationForm.asMap().containsKey(k) &&
          (targetedMutationControl.value ?? []).asMap().containsKey(k)) {
        toUpdate.add(v);
      } else {
        toAdd.add(v);
      }
    });

    if (toUpdate.isNotEmpty) {
      targetedMutationControl.updateValue(
          toUpdate.map((e) => e.formElements().rawValue).toList(),
          updateParent: updateParent,
          emitEvent: emitEvent);
    }

    if (toAdd.isNotEmpty) {
      toAdd.forEach((e) {
        targetedMutationControl.add(e.formElements(),
            updateParent: updateParent, emitEvent: emitEvent);
      });
    }
  }

  void targetedMutationInsert(
    int i,
    TargetedMutation value, {
    bool updateParent = true,
    bool emitEvent = true,
  }) {
    if (targetedMutationTargetedMutationForm.length < i) {
      addTargetedMutationItem(value);
      return;
    }

    final item = TargetedMutationForm(
      value,
      form,
      pathBuilder('targetedMutation.$i'),
    );

    targetedMutationTargetedMutationForm.insert(i, item);

    targetedMutationTargetedMutationForm.asMap().forEach((k, v) {
      if (k > i) {
        targetedMutationTargetedMutationForm[k] = v.copyWithPath(
          pathBuilder("targetedMutation.$k"),
        );
      }
    });

    targetedMutationControl.insert(
      i,
      item.formElements(),
      updateParent: updateParent,
      emitEvent: emitEvent,
    );
  }

  void targetedMutationClear({
    bool updateParent = true,
    bool emitEvent = true,
  }) {
    targetedMutationTargetedMutationForm.clear();
    targetedMutationControl.clear(
        updateParent: updateParent, emitEvent: emitEvent);
  }

  void labelValuePatch(
    String? value, {
    bool updateParent = true,
    bool emitEvent = true,
  }) {
    labelControl?.patchValue(value,
        updateParent: updateParent, emitEvent: emitEvent);
  }

  void notesValuePatch(
    String? value, {
    bool updateParent = true,
    bool emitEvent = true,
  }) {
    notesControl?.patchValue(value,
        updateParent: updateParent, emitEvent: emitEvent);
  }

  void brainStructureValuePatch(
    BrainStructure? value, {
    bool updateParent = true,
    bool emitEvent = true,
  }) {
    brainStructureControl?.patchValue(value,
        updateParent: updateParent, emitEvent: emitEvent);
  }

  void animalValuePatch(
    Animal? value, {
    bool updateParent = true,
    bool emitEvent = true,
  }) {
    animalControl?.updateValue(
        AnimalForm(value, form, null).formElements().rawValue,
        updateParent: updateParent,
        emitEvent: emitEvent);
  }

  void microscopyMethodValuePatch(
    MicroscopyMethod? value, {
    bool updateParent = true,
    bool emitEvent = true,
  }) {
    microscopyMethodControl?.updateValue(
        MicroscopyMethodForm(value, form, null).formElements().rawValue,
        updateParent: updateParent,
        emitEvent: emitEvent);
  }

  void targetedMutationValuePatch(
    List<TargetedMutation> value, {
    bool updateParent = true,
    bool emitEvent = true,
  }) {
    final keys = targetedMutationTargetedMutationForm.asMap().keys;

    final toPatch = <TargetedMutationForm>[];
    (value).asMap().forEach(
      (k, v) {
        if (keys.contains(k)) {
          final patch =
              TargetedMutationForm(v, form, pathBuilder("targetedMutation.$k"));
          targetedMutationTargetedMutationForm[k] = patch;
          toPatch.add(patch);
        }
      },
    );

    targetedMutationControl.patchValue(
        toPatch.map((e) => e.formElements().rawValue).toList(),
        updateParent: updateParent,
        emitEvent: emitEvent);
  }

  void labelValueReset(
    String? value, {
    bool updateParent = true,
    bool emitEvent = true,
    bool removeFocus = false,
    bool? disabled,
  }) =>
      labelControl?.reset(
          value: value, updateParent: updateParent, emitEvent: emitEvent);
  void notesValueReset(
    String? value, {
    bool updateParent = true,
    bool emitEvent = true,
    bool removeFocus = false,
    bool? disabled,
  }) =>
      notesControl?.reset(
          value: value, updateParent: updateParent, emitEvent: emitEvent);
  void brainStructureValueReset(
    BrainStructure? value, {
    bool updateParent = true,
    bool emitEvent = true,
    bool removeFocus = false,
    bool? disabled,
  }) =>
      brainStructureControl?.reset(
          value: value, updateParent: updateParent, emitEvent: emitEvent);
  void animalValueReset(
    Animal? value, {
    bool updateParent = true,
    bool emitEvent = true,
    bool removeFocus = false,
    bool? disabled,
  }) =>
      animalControl?.reset(
          value: AnimalForm(value, FormGroup({}), null).formElements().rawValue,
          updateParent: updateParent,
          emitEvent: emitEvent);
  void microscopyMethodValueReset(
    MicroscopyMethod? value, {
    bool updateParent = true,
    bool emitEvent = true,
    bool removeFocus = false,
    bool? disabled,
  }) =>
      microscopyMethodControl?.reset(
          value: MicroscopyMethodForm(value, FormGroup({}), null)
              .formElements()
              .rawValue,
          updateParent: updateParent,
          emitEvent: emitEvent);
  void targetedMutationValueReset(
    List<TargetedMutation> value, {
    bool updateParent = true,
    bool emitEvent = true,
    bool removeFocus = false,
    bool? disabled,
  }) =>
      targetedMutationControl.reset(
          value: value
              .map((e) => TargetedMutationForm(e, FormGroup({}), null)
                  .formElements()
                  .rawValue)
              .toList(),
          updateParent: updateParent,
          emitEvent: emitEvent);
  FormControl<String>? get labelControl => containsLabel
      ? form.control(labelControlPath()) as FormControl<String>?
      : null;
  FormControl<String>? get notesControl => containsNotes
      ? form.control(notesControlPath()) as FormControl<String>?
      : null;
  FormControl<BrainStructure>? get brainStructureControl =>
      containsBrainStructure
          ? form.control(brainStructureControlPath())
              as FormControl<BrainStructure>?
          : null;
  FormGroup? get animalControl =>
      containsAnimal ? form.control(animalControlPath()) as FormGroup? : null;
  FormGroup? get microscopyMethodControl => containsMicroscopyMethod
      ? form.control(microscopyMethodControlPath()) as FormGroup?
      : null;
  FormArray<Map<String, Object?>> get targetedMutationControl =>
      form.control(targetedMutationControlPath())
          as FormArray<Map<String, Object?>>;
  void labelSetDisabled(
    bool disabled, {
    bool updateParent = true,
    bool emitEvent = true,
  }) {
    if (disabled) {
      labelControl?.markAsDisabled(
        updateParent: updateParent,
        emitEvent: emitEvent,
      );
    } else {
      labelControl?.markAsEnabled(
        updateParent: updateParent,
        emitEvent: emitEvent,
      );
    }
  }

  void notesSetDisabled(
    bool disabled, {
    bool updateParent = true,
    bool emitEvent = true,
  }) {
    if (disabled) {
      notesControl?.markAsDisabled(
        updateParent: updateParent,
        emitEvent: emitEvent,
      );
    } else {
      notesControl?.markAsEnabled(
        updateParent: updateParent,
        emitEvent: emitEvent,
      );
    }
  }

  void brainStructureSetDisabled(
    bool disabled, {
    bool updateParent = true,
    bool emitEvent = true,
  }) {
    if (disabled) {
      brainStructureControl?.markAsDisabled(
        updateParent: updateParent,
        emitEvent: emitEvent,
      );
    } else {
      brainStructureControl?.markAsEnabled(
        updateParent: updateParent,
        emitEvent: emitEvent,
      );
    }
  }

  void animalSetDisabled(
    bool disabled, {
    bool updateParent = true,
    bool emitEvent = true,
  }) {
    if (disabled) {
      animalControl?.markAsDisabled(
        updateParent: updateParent,
        emitEvent: emitEvent,
      );
    } else {
      animalControl?.markAsEnabled(
        updateParent: updateParent,
        emitEvent: emitEvent,
      );
    }
  }

  void microscopyMethodSetDisabled(
    bool disabled, {
    bool updateParent = true,
    bool emitEvent = true,
  }) {
    if (disabled) {
      microscopyMethodControl?.markAsDisabled(
        updateParent: updateParent,
        emitEvent: emitEvent,
      );
    } else {
      microscopyMethodControl?.markAsEnabled(
        updateParent: updateParent,
        emitEvent: emitEvent,
      );
    }
  }

  void targetedMutationSetDisabled(
    bool disabled, {
    bool updateParent = true,
    bool emitEvent = true,
  }) {
    if (disabled) {
      targetedMutationControl.markAsDisabled(
        updateParent: updateParent,
        emitEvent: emitEvent,
      );
    } else {
      targetedMutationControl.markAsEnabled(
        updateParent: updateParent,
        emitEvent: emitEvent,
      );
    }
  }

  ExtendedControl<List<Map<String, Object?>?>, List<TargetedMutationForm>>
      get targetedMutationExtendedControl => ExtendedControl<
              List<Map<String, Object?>?>, List<TargetedMutationForm>>(
          form.control(targetedMutationControlPath())
              as FormArray<Map<String, Object?>>,
          () => targetedMutationTargetedMutationForm);
  void addTargetedMutationItem(TargetedMutation value) {
    final formClass = TargetedMutationForm(
        value,
        form,
        pathBuilder(
            'targetedMutation.${targetedMutationTargetedMutationForm.length}'));

    targetedMutationTargetedMutationForm.add(formClass);
    targetedMutationControl.add(formClass.formElements());
  }

  void removeTargetedMutationItemAtIndex(int i) {
    if (targetedMutationTargetedMutationForm.asMap().containsKey(i) &&
        (targetedMutationControl.value ?? []).asMap().containsKey(i)) {
      targetedMutationTargetedMutationForm.removeAt(i);

      targetedMutationTargetedMutationForm.asMap().forEach((k, v) {
        targetedMutationTargetedMutationForm[k] =
            v.copyWithPath(pathBuilder("targetedMutation.$k"));
      });

      targetedMutationControl.removeAt(i);
    }
  }

  void addTargetedMutationItemList(List<TargetedMutation> value) {
    value.map((e) => addTargetedMutationItem(e));
  }

  CreateDataset get model {
    if (!form.valid) {
      debugPrint(
        'Prefer not to call `model` on non-valid form it could cause unexpected exceptions in case you created a non-nullable field in model and expect it to be guarded by some kind of `required` validator.',
      );
    }
    return CreateDataset(
        label: _labelValue,
        notes: _notesValue,
        animal: _animalValue,
        targetedMutation: _targetedMutationValue,
        microscopyMethod: _microscopyMethodValue,
        brainStructure: _brainStructureValue);
  }

  CreateDatasetForm copyWithPath(String? path) {
    return CreateDatasetForm(createDataset, form, path);
  }

  void updateValue(
    CreateDataset value, {
    bool updateParent = true,
    bool emitEvent = true,
  }) =>
      form.updateValue(
          CreateDatasetForm(value, FormGroup({}), null).formElements().rawValue,
          updateParent: updateParent,
          emitEvent: emitEvent);
  void resetValue(
    CreateDataset value, {
    bool updateParent = true,
    bool emitEvent = true,
  }) =>
      form.reset(
          value: CreateDatasetForm(value, FormGroup({}), null)
              .formElements()
              .rawValue,
          updateParent: updateParent,
          emitEvent: emitEvent);
  void reset({
    bool updateParent = true,
    bool emitEvent = true,
  }) =>
      form.reset(
          value: formElements().rawValue,
          updateParent: updateParent,
          emitEvent: emitEvent);
  String pathBuilder(String? pathItem) =>
      [path, pathItem].whereType<String>().join(".");
  FormGroup formElements() => FormGroup({
        labelControlName: FormControl<String>(
            value: createDataset?.label,
            validators: [],
            asyncValidators: [],
            asyncValidatorsDebounceTime: 250,
            disabled: false,
            touched: false),
        notesControlName: FormControl<String>(
            value: createDataset?.notes,
            validators: [],
            asyncValidators: [],
            asyncValidatorsDebounceTime: 250,
            disabled: false,
            touched: false),
        targetedMutationControlName: FormArray(
            targetedMutationTargetedMutationForm
                .map((e) => e.formElements())
                .toList(),
            validators: [],
            asyncValidators: [],
            asyncValidatorsDebounceTime: 250,
            disabled: false),
        brainStructureControlName: FormControl<BrainStructure>(
            value: createDataset?.brainStructure,
            validators: [],
            asyncValidators: [],
            asyncValidatorsDebounceTime: 250,
            disabled: false,
            touched: false),
        animalControlName: animalForm.formElements(),
        microscopyMethodControlName: microscopyMethodForm.formElements()
      },
          validators: [],
          asyncValidators: [],
          asyncValidatorsDebounceTime: 250,
          disabled: false);
}

class AnimalForm implements FormModel<Animal> {
  AnimalForm(
    this.animal,
    this.form,
    this.path,
  ) {}

  static String speciesControlName = "species";

  final Animal? animal;

  final FormGroup form;

  final String? path;

  String speciesControlPath() => pathBuilder(speciesControlName);
  String get _speciesValue => speciesControl.value ?? "";
  bool get containsSpecies {
    try {
      form.control(speciesControlPath());
      return true;
    } catch (e) {
      return false;
    }
  }

  Object? get speciesErrors => speciesControl.errors;
  void get speciesFocus => form.focus(speciesControlPath());
  void speciesValueUpdate(
    String value, {
    bool updateParent = true,
    bool emitEvent = true,
  }) {
    speciesControl.updateValue(value,
        updateParent: updateParent, emitEvent: emitEvent);
  }

  void speciesValuePatch(
    String value, {
    bool updateParent = true,
    bool emitEvent = true,
  }) {
    speciesControl.patchValue(value,
        updateParent: updateParent, emitEvent: emitEvent);
  }

  void speciesValueReset(
    String value, {
    bool updateParent = true,
    bool emitEvent = true,
    bool removeFocus = false,
    bool? disabled,
  }) =>
      speciesControl.reset(
          value: value, updateParent: updateParent, emitEvent: emitEvent);
  FormControl<String> get speciesControl =>
      form.control(speciesControlPath()) as FormControl<String>;
  void speciesSetDisabled(
    bool disabled, {
    bool updateParent = true,
    bool emitEvent = true,
  }) {
    if (disabled) {
      speciesControl.markAsDisabled(
        updateParent: updateParent,
        emitEvent: emitEvent,
      );
    } else {
      speciesControl.markAsEnabled(
        updateParent: updateParent,
        emitEvent: emitEvent,
      );
    }
  }

  Animal get model {
    if (!form.valid) {
      debugPrint(
        'Prefer not to call `model` on non-valid form it could cause unexpected exceptions in case you created a non-nullable field in model and expect it to be guarded by some kind of `required` validator.',
      );
    }
    return Animal(species: _speciesValue);
  }

  AnimalForm copyWithPath(String? path) {
    return AnimalForm(animal, form, path);
  }

  void updateValue(
    Animal? value, {
    bool updateParent = true,
    bool emitEvent = true,
  }) =>
      form.updateValue(
          AnimalForm(value, FormGroup({}), null).formElements().rawValue,
          updateParent: updateParent,
          emitEvent: emitEvent);
  void resetValue(
    Animal? value, {
    bool updateParent = true,
    bool emitEvent = true,
  }) =>
      form.reset(
          value: AnimalForm(value, FormGroup({}), null).formElements().rawValue,
          updateParent: updateParent,
          emitEvent: emitEvent);
  void reset({
    bool updateParent = true,
    bool emitEvent = true,
  }) =>
      form.reset(
          value: formElements().rawValue,
          updateParent: updateParent,
          emitEvent: emitEvent);
  String pathBuilder(String? pathItem) =>
      [path, pathItem].whereType<String>().join(".");
  FormGroup formElements() => FormGroup({
        speciesControlName: FormControl<String>(
            value: animal?.species,
            validators: [requiredValidator],
            asyncValidators: [],
            asyncValidatorsDebounceTime: 250,
            disabled: false,
            touched: false)
      },
          validators: [],
          asyncValidators: [],
          asyncValidatorsDebounceTime: 250,
          disabled: false);
}

class MicroscopyMethodForm implements FormModel<MicroscopyMethod> {
  MicroscopyMethodForm(
    this.microscopyMethod,
    this.form,
    this.path,
  ) {}

  static String nameControlName = "name";

  final MicroscopyMethod? microscopyMethod;

  final FormGroup form;

  final String? path;

  String nameControlPath() => pathBuilder(nameControlName);
  String get _nameValue => nameControl.value ?? "";
  bool get containsName {
    try {
      form.control(nameControlPath());
      return true;
    } catch (e) {
      return false;
    }
  }

  Object? get nameErrors => nameControl.errors;
  void get nameFocus => form.focus(nameControlPath());
  void nameValueUpdate(
    String value, {
    bool updateParent = true,
    bool emitEvent = true,
  }) {
    nameControl.updateValue(value,
        updateParent: updateParent, emitEvent: emitEvent);
  }

  void nameValuePatch(
    String value, {
    bool updateParent = true,
    bool emitEvent = true,
  }) {
    nameControl.patchValue(value,
        updateParent: updateParent, emitEvent: emitEvent);
  }

  void nameValueReset(
    String value, {
    bool updateParent = true,
    bool emitEvent = true,
    bool removeFocus = false,
    bool? disabled,
  }) =>
      nameControl.reset(
          value: value, updateParent: updateParent, emitEvent: emitEvent);
  FormControl<String> get nameControl =>
      form.control(nameControlPath()) as FormControl<String>;
  void nameSetDisabled(
    bool disabled, {
    bool updateParent = true,
    bool emitEvent = true,
  }) {
    if (disabled) {
      nameControl.markAsDisabled(
        updateParent: updateParent,
        emitEvent: emitEvent,
      );
    } else {
      nameControl.markAsEnabled(
        updateParent: updateParent,
        emitEvent: emitEvent,
      );
    }
  }

  MicroscopyMethod get model {
    if (!form.valid) {
      debugPrint(
        'Prefer not to call `model` on non-valid form it could cause unexpected exceptions in case you created a non-nullable field in model and expect it to be guarded by some kind of `required` validator.',
      );
    }
    return MicroscopyMethod(name: _nameValue);
  }

  MicroscopyMethodForm copyWithPath(String? path) {
    return MicroscopyMethodForm(microscopyMethod, form, path);
  }

  void updateValue(
    MicroscopyMethod? value, {
    bool updateParent = true,
    bool emitEvent = true,
  }) =>
      form.updateValue(
          MicroscopyMethodForm(value, FormGroup({}), null)
              .formElements()
              .rawValue,
          updateParent: updateParent,
          emitEvent: emitEvent);
  void resetValue(
    MicroscopyMethod? value, {
    bool updateParent = true,
    bool emitEvent = true,
  }) =>
      form.reset(
          value: MicroscopyMethodForm(value, FormGroup({}), null)
              .formElements()
              .rawValue,
          updateParent: updateParent,
          emitEvent: emitEvent);
  void reset({
    bool updateParent = true,
    bool emitEvent = true,
  }) =>
      form.reset(
          value: formElements().rawValue,
          updateParent: updateParent,
          emitEvent: emitEvent);
  String pathBuilder(String? pathItem) =>
      [path, pathItem].whereType<String>().join(".");
  FormGroup formElements() => FormGroup({
        nameControlName: FormControl<String>(
            value: microscopyMethod?.name,
            validators: [requiredValidator],
            asyncValidators: [],
            asyncValidatorsDebounceTime: 250,
            disabled: false,
            touched: false)
      },
          validators: [],
          asyncValidators: [],
          asyncValidatorsDebounceTime: 250,
          disabled: false);
}

class TargetedMutationForm implements FormModel<TargetedMutation> {
  TargetedMutationForm(
    this.targetedMutation,
    this.form,
    this.path,
  ) {}

  static String geneControlName = "gene";

  static String isKnockOutControlName = "isKnockOut";

  static String methodControlName = "method";

  final TargetedMutation? targetedMutation;

  final FormGroup form;

  final String? path;

  String geneControlPath() => pathBuilder(geneControlName);
  String isKnockOutControlPath() => pathBuilder(isKnockOutControlName);
  String methodControlPath() => pathBuilder(methodControlName);
  String get _geneValue => geneControl.value ?? "";
  bool get _isKnockOutValue => isKnockOutControl.value as bool;
  String get _methodValue => methodControl.value ?? "";
  bool get containsGene {
    try {
      form.control(geneControlPath());
      return true;
    } catch (e) {
      return false;
    }
  }

  bool get containsIsKnockOut {
    try {
      form.control(isKnockOutControlPath());
      return true;
    } catch (e) {
      return false;
    }
  }

  bool get containsMethod {
    try {
      form.control(methodControlPath());
      return true;
    } catch (e) {
      return false;
    }
  }

  Object? get geneErrors => geneControl.errors;
  Object? get isKnockOutErrors => isKnockOutControl.errors;
  Object? get methodErrors => methodControl.errors;
  void get geneFocus => form.focus(geneControlPath());
  void get isKnockOutFocus => form.focus(isKnockOutControlPath());
  void get methodFocus => form.focus(methodControlPath());
  void geneValueUpdate(
    String value, {
    bool updateParent = true,
    bool emitEvent = true,
  }) {
    geneControl.updateValue(value,
        updateParent: updateParent, emitEvent: emitEvent);
  }

  void isKnockOutValueUpdate(
    bool value, {
    bool updateParent = true,
    bool emitEvent = true,
  }) {
    isKnockOutControl.updateValue(value,
        updateParent: updateParent, emitEvent: emitEvent);
  }

  void methodValueUpdate(
    String value, {
    bool updateParent = true,
    bool emitEvent = true,
  }) {
    methodControl.updateValue(value,
        updateParent: updateParent, emitEvent: emitEvent);
  }

  void geneValuePatch(
    String value, {
    bool updateParent = true,
    bool emitEvent = true,
  }) {
    geneControl.patchValue(value,
        updateParent: updateParent, emitEvent: emitEvent);
  }

  void isKnockOutValuePatch(
    bool value, {
    bool updateParent = true,
    bool emitEvent = true,
  }) {
    isKnockOutControl.patchValue(value,
        updateParent: updateParent, emitEvent: emitEvent);
  }

  void methodValuePatch(
    String value, {
    bool updateParent = true,
    bool emitEvent = true,
  }) {
    methodControl.patchValue(value,
        updateParent: updateParent, emitEvent: emitEvent);
  }

  void geneValueReset(
    String value, {
    bool updateParent = true,
    bool emitEvent = true,
    bool removeFocus = false,
    bool? disabled,
  }) =>
      geneControl.reset(
          value: value, updateParent: updateParent, emitEvent: emitEvent);
  void isKnockOutValueReset(
    bool value, {
    bool updateParent = true,
    bool emitEvent = true,
    bool removeFocus = false,
    bool? disabled,
  }) =>
      isKnockOutControl.reset(
          value: value, updateParent: updateParent, emitEvent: emitEvent);
  void methodValueReset(
    String value, {
    bool updateParent = true,
    bool emitEvent = true,
    bool removeFocus = false,
    bool? disabled,
  }) =>
      methodControl.reset(
          value: value, updateParent: updateParent, emitEvent: emitEvent);
  FormControl<String> get geneControl =>
      form.control(geneControlPath()) as FormControl<String>;
  FormControl<bool> get isKnockOutControl =>
      form.control(isKnockOutControlPath()) as FormControl<bool>;
  FormControl<String> get methodControl =>
      form.control(methodControlPath()) as FormControl<String>;
  void geneSetDisabled(
    bool disabled, {
    bool updateParent = true,
    bool emitEvent = true,
  }) {
    if (disabled) {
      geneControl.markAsDisabled(
        updateParent: updateParent,
        emitEvent: emitEvent,
      );
    } else {
      geneControl.markAsEnabled(
        updateParent: updateParent,
        emitEvent: emitEvent,
      );
    }
  }

  void isKnockOutSetDisabled(
    bool disabled, {
    bool updateParent = true,
    bool emitEvent = true,
  }) {
    if (disabled) {
      isKnockOutControl.markAsDisabled(
        updateParent: updateParent,
        emitEvent: emitEvent,
      );
    } else {
      isKnockOutControl.markAsEnabled(
        updateParent: updateParent,
        emitEvent: emitEvent,
      );
    }
  }

  void methodSetDisabled(
    bool disabled, {
    bool updateParent = true,
    bool emitEvent = true,
  }) {
    if (disabled) {
      methodControl.markAsDisabled(
        updateParent: updateParent,
        emitEvent: emitEvent,
      );
    } else {
      methodControl.markAsEnabled(
        updateParent: updateParent,
        emitEvent: emitEvent,
      );
    }
  }

  TargetedMutation get model {
    if (!form.valid) {
      debugPrint(
        'Prefer not to call `model` on non-valid form it could cause unexpected exceptions in case you created a non-nullable field in model and expect it to be guarded by some kind of `required` validator.',
      );
    }
    return TargetedMutation(
        gene: _geneValue, isKnockOut: _isKnockOutValue, method: _methodValue);
  }

  TargetedMutationForm copyWithPath(String? path) {
    return TargetedMutationForm(targetedMutation, form, path);
  }

  void updateValue(
    TargetedMutation value, {
    bool updateParent = true,
    bool emitEvent = true,
  }) =>
      form.updateValue(
          TargetedMutationForm(value, FormGroup({}), null)
              .formElements()
              .rawValue,
          updateParent: updateParent,
          emitEvent: emitEvent);
  void resetValue(
    TargetedMutation value, {
    bool updateParent = true,
    bool emitEvent = true,
  }) =>
      form.reset(
          value: TargetedMutationForm(value, FormGroup({}), null)
              .formElements()
              .rawValue,
          updateParent: updateParent,
          emitEvent: emitEvent);
  void reset({
    bool updateParent = true,
    bool emitEvent = true,
  }) =>
      form.reset(
          value: formElements().rawValue,
          updateParent: updateParent,
          emitEvent: emitEvent);
  String pathBuilder(String? pathItem) =>
      [path, pathItem].whereType<String>().join(".");
  FormGroup formElements() => FormGroup({
        geneControlName: FormControl<String>(
            value: targetedMutation?.gene,
            validators: [requiredValidator],
            asyncValidators: [],
            asyncValidatorsDebounceTime: 250,
            disabled: false,
            touched: false),
        isKnockOutControlName: FormControl<bool>(
            value: targetedMutation?.isKnockOut,
            validators: [],
            asyncValidators: [],
            asyncValidatorsDebounceTime: 250,
            disabled: false,
            touched: false),
        methodControlName: FormControl<String>(
            value: targetedMutation?.method,
            validators: [requiredValidator],
            asyncValidators: [],
            asyncValidatorsDebounceTime: 250,
            disabled: false,
            touched: false)
      },
          validators: [],
          asyncValidators: [],
          asyncValidatorsDebounceTime: 250,
          disabled: false);
}

class ReactiveCreateDatasetFormArrayBuilder<T> extends StatelessWidget {
  const ReactiveCreateDatasetFormArrayBuilder({
    Key? key,
    this.control,
    this.formControl,
    this.builder,
    required this.itemBuilder,
  })  : assert(control != null || formControl != null,
            "You have to specify `control` or `formControl`!"),
        super(key: key);

  final FormArray<T>? formControl;

  final FormArray<T>? Function(CreateDatasetForm formModel)? control;

  final Widget Function(BuildContext context, List<Widget> itemList,
      CreateDatasetForm formModel)? builder;

  final Widget Function(
          BuildContext context, int i, T? item, CreateDatasetForm formModel)
      itemBuilder;

  @override
  Widget build(BuildContext context) {
    final formModel = ReactiveCreateDatasetForm.of(context);

    if (formModel == null) {
      throw FormControlParentNotFoundException(this);
    }

    return ReactiveFormArray<T>(
      formArray: formControl ?? control?.call(formModel),
      builder: (context, formArray, child) {
        final itemList = (formArray.value ?? [])
            .asMap()
            .map((i, item) {
              return MapEntry(
                i,
                itemBuilder(
                  context,
                  i,
                  item,
                  formModel,
                ),
              );
            })
            .values
            .toList();

        return builder?.call(
              context,
              itemList,
              formModel,
            ) ??
            Column(children: itemList);
      },
    );
  }
}

class ReactiveCreateDatasetFormFormGroupArrayBuilder<V>
    extends StatelessWidget {
  const ReactiveCreateDatasetFormFormGroupArrayBuilder({
    Key? key,
    this.extended,
    this.getExtended,
    this.builder,
    required this.itemBuilder,
  })  : assert(extended != null || getExtended != null,
            "You have to specify `control` or `formControl`!"),
        super(key: key);

  final ExtendedControl<List<Map<String, Object?>?>, List<V>>? extended;

  final ExtendedControl<List<Map<String, Object?>?>, List<V>> Function(
      CreateDatasetForm formModel)? getExtended;

  final Widget Function(BuildContext context, List<Widget> itemList,
      CreateDatasetForm formModel)? builder;

  final Widget Function(
          BuildContext context, int i, V? item, CreateDatasetForm formModel)
      itemBuilder;

  @override
  Widget build(BuildContext context) {
    final formModel = ReactiveCreateDatasetForm.of(context);

    if (formModel == null) {
      throw FormControlParentNotFoundException(this);
    }

    final value = (extended ?? getExtended?.call(formModel))!;

    return StreamBuilder<List<Map<String, Object?>?>?>(
      stream: value.control.valueChanges,
      builder: (context, snapshot) {
        final itemList = (value.value() ?? <V>[])
            .asMap()
            .map((i, item) => MapEntry(
                  i,
                  itemBuilder(
                    context,
                    i,
                    item,
                    formModel,
                  ),
                ))
            .values
            .toList();

        return builder?.call(
              context,
              itemList,
              formModel,
            ) ??
            Column(children: itemList);
      },
    );
  }
}
